import { EOrientation } from '../../types'
import { MIN_WIDTH_CELL_ENTITY } from "../constant"
import { CellEntity, TableElement } from "../type"

export class TableUtils {
  // Создает  элемент для таблицы хедер,боди,строку или ячейку
  static createTableElement(type: TableElement) {
    const divElement = document.createElement('div')
    divElement.classList.add(type)
    return divElement
  }

  static getCellType(cell: HTMLDivElement): CellEntity {
    if (cell.querySelector('.signer'))
      return 'signer'
    if (cell.querySelector('.user'))
      return 'user'
    if (cell.querySelector('.location'))
      return 'location'
    if (cell.querySelector('.text_options'))
      return 'text_options'
    if (cell.querySelector('.text'))
      return 'text'
    if (cell.querySelector('.digit'))
      return 'digit'
    if (cell.querySelector('.date'))
      return 'date'
    if (cell.querySelector('.time'))
      return 'time'
    if (cell.querySelector('.datetime'))
      return 'datetime'
    if (cell.querySelector('.company'))
      return 'company'
    return 'other'
  }

  static getTableElement(tableElement: HTMLDivElement, selector: string) {
    return [...tableElement.querySelectorAll(`${selector}`) ?? []]
  }

  static getMinWidthForEntityCells(entity: CellEntity[], orientation: EOrientation): number[] {
    return entity.map((entity) => MIN_WIDTH_CELL_ENTITY[entity])
  }

  static insertInHiddenDom(elem: Node) {
    const iframe = document.querySelector('.iframe-hidden-dom') as HTMLIFrameElement
    const placeForInsert = iframe.contentDocument?.body.querySelector('.hidden-dom .template-constructor')
    placeForInsert?.appendChild(elem)
  }
}
